#include <stdio.h>

#ifndef TYPE
# define TYPE int
#endif

TYPE f(TYPE *a, int len);
static unsigned long long get_ticks(void);
  
#define LENGTH 1000
#define ITERS  100000
#ifndef SCALE
# define SCALE (4.0 / 3.6)
#endif

TYPE a[LENGTH];

int main(int argc, char **argv)
{
  int i;
  unsigned long long start_ticks, end_ticks;

  for (i = 0; i < LENGTH; i++)
    a[i] = i;

  start_ticks = get_ticks();

  for (i = 0; i < ITERS; i++) {
    f(a, LENGTH);
  }

  end_ticks = get_ticks();

  printf("%f\n", ((double)(end_ticks - start_ticks) / (LENGTH * ITERS)) * SCALE);

  return 0;
}

static inline unsigned long long get_ticks(void)
{
  unsigned int lo, hi;
  // RDTSC copies contents of 64-bit TSC into EDX:EAX
  asm volatile("rdtsc" : "=a" (lo), "=d" (hi));
  return (unsigned long long)hi << 32 | lo;
}
